Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  abstract class ExtensionMethods extends SubComponent with Transform with TypingTransformers

  Perform Step 1 in the inline classes SIP: Creates extension methods for all methods in a value class, except parameter or super accessors, or constructors.

  Perform Step 1 in the inline classes SIP: Creates extension methods for all methods in a value class, except parameter or super accessors, or constructors.

  Definition Classes
    transform
  Version

    2.10

- Extender
- ExtensionMethodType
- Phase
- StdPhase
- SubstututeRecursion
- TypingTransformer

c

scala.tools.nsc.transform.ExtensionMethods

# Extender 

###

#### class Extender extends TypingTransformer

Source
  ExtensionMethods.scala

Linear Supertypes
ExtensionMethods.TypingTransformer, Global.Transformer, Global.Transformer, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Extender
2. TypingTransformer
3. Transformer
4. Transformer
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Extender(unit: Global.CompilationUnit)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Extender to any2stringadd[Extender] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Extender, B)
   Implicit
     This member is added by an implicit conversion from Extender to ArrowAssoc[Extender] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def atOwner[A](tree: Global.Tree, owner: Global.Symbol)(trans: ⇒ A): A
   Definition Classes
     TypingTransformer
8.  final def atOwner[A](owner: Global.Symbol)(trans: ⇒ A): A
   Definition Classes
     TypingTransformer → Transformer
9.  def checkNonCyclic(pos: Global.Position, seen: Set[Global.Symbol], clazz: Global.Symbol): Unit
10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
11.  var curTree: Global.Tree
    Attributes
      protected
    Definition Classes
      TypingTransformer
12.  def currentClass: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
13.  def currentMethod: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
14.  var currentOwner: Global.Symbol
    Attributes
      protected[scala]
    Definition Classes
      Transformer
15.  def ensuring(cond: (Extender) ⇒ Boolean, msg: ⇒ Any): Extender
    Implicit
      This member is added by an implicit conversion from Extender to Ensuring[Extender] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: (Extender) ⇒ Boolean): Extender
    Implicit
      This member is added by an implicit conversion from Extender to Ensuring[Extender] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean, msg: ⇒ Any): Extender
    Implicit
      This member is added by an implicit conversion from Extender to Ensuring[Extender] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  def ensuring(cond: Boolean): Extender
    Implicit
      This member is added by an implicit conversion from Extender to Ensuring[Extender] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
19.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
21.  def extensionMethInfo(extensionMeth: Global.Symbol, origInfo: Global.Type, clazz: Global.Symbol): Global.Type

    We will need to clone the info of the original method (which obtains clones of the method type parameters), clone the type parameters of the value class, and create a new polymethod with the union of all those type parameters, with their infos adjusted to be consistent with their new home.

    We will need to clone the info of the original method (which obtains clones of the method type parameters), clone the type parameters of the value class, and create a new polymethod with the union of all those type parameters, with their infos adjusted to be consistent with their new home. Example:

    class Foo[+A <: AnyRef](val xs: List[A]) extends AnyVal { def baz[B >: A](x: B): List[B] = x :: xs // baz has to be transformed into this extension method, where // A is cloned from class Foo and B is cloned from method baz: // def extension$baz[B >: A <: Any, A >: Nothing <: AnyRef]($this: Foo[A])(x: B): List[B] }

    TODO: factor out the logic for consolidating type parameters from a class and a method for re-use elsewhere, because nobody will get this right without some higher level facilities.

22.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
23.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Extender to StringFormat[Extender] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
24.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
25.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
26.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
27.  var localTyper: (analyzer)#Typer
    Definition Classes
      TypingTransformer
28.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
29.  final def notify(): Unit
    Definition Classes
      AnyRef
30.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
31.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
32.  def toString(): String
    Definition Classes
      AnyRef → Any
33.  def transform(tree: Global.Tree): Global.Tree
    Definition Classes
      Extender → TypingTransformer → Transformer
34.  def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]
    Definition Classes
      Transformer
35.  def transformIdents(trees: List[Global.Ident]): List[Global.Ident]
    Definition Classes
      Transformer
36.  def transformMemberDefs(trees: List[Global.MemberDef]): List[Global.MemberDef]
    Definition Classes
      Transformer
37.  def transformModifiers(mods: Global.Modifiers): Global.Modifiers
    Definition Classes
      Transformer
38.  def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]
    Definition Classes
      Extender → Transformer
39.  def transformTemplate(tree: Global.Template): Global.Template
    Definition Classes
      Transformer
40.  def transformTrees(trees: List[Global.Tree]): List[Global.Tree]
    Definition Classes
      Transformer
41.  def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]
    Definition Classes
      Transformer
42.  def transformUnit(unit: Global.CompilationUnit): Unit
    Definition Classes
      Transformer
43.  def transformValDef(tree: Global.ValDef): Global.ValDef
    Definition Classes
      Transformer
44.  def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]
    Definition Classes
      Transformer
45.  def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]
    Definition Classes
      Transformer
46.  val treeCopy: Global.TreeCopier
    Definition Classes
      Transformer
47.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
48.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
49.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
50.  def →[B](y: B): (Extender, B)
    Implicit
      This member is added by an implicit conversion from Extender to ArrowAssoc[Extender] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from ExtensionMethods.TypingTransformer

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Extender to any2stringadd[Extender]

### Inherited by implicit conversion StringFormat from Extender to StringFormat[Extender]

### Inherited by implicit conversion Ensuring from Extender to Ensuring[Extender]

### Inherited by implicit conversion ArrowAssoc from Extender to ArrowAssoc[Extender]

### Ungrouped